%define name dhcp
%define	version	3.0 
%define candidate rc12
%define release 0.%{candidate}.1mdk
%define url  ftp://ftp.isc.org/isc/dhcp

Summary: The ISC DHCP (Dynamic Host Configuration Protocol) server/relay agent/client
Name:		%{name}
Epoch: 1
Version:	%{version}
Release:	%{release}
License:	distributable
Group:		System/Servers
Url:		http://www.isc.org/dhcp.html
Source0:	%{url}/%{name}-%{version}%{candidate}.tar.bz2
Source1:	dhcpd.conf.sample
Source2:	dhcpd.init
Source3:	dhcp-dynamic-dns-examples.tar.bz2
Source4:	dhcrelay.init
Source5:	update_dhcp.pl
Patch0:		dhcp-conf-linux.patch.bz2
BuildRequires:	perl sed gcc groff-for-man make patch tar bzip2 
Prereq:		/sbin/chkconfig /sbin/service 
Requires:	/bin/sh
BuildRoot:	%{_tmppath}/%{name}-%{version}%{candidate}-root
Obsoletes:	dhcpd
Prefix:		%{_prefix}

%description 
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows
individual devices on an IP network to get their own network
configuration information (IP address, subnetmask, broadcast address,
etc.) from a DHCP server.  The overall purpose of DHCP is to make it
easier to administer a large network.  The dhcp package includes the
DHCP server and a DHCP relay agent.

You will also need to install the dhcp-client or dhcpcd package,
or pump or dhcpxd, which provides the DHCP client daemon, on
client machines.
If you want the DHCP server and/or relay, you will al
so need to
install the dhcp-server and/or dhcp-relay packages.

%package common
Summary: The ISC DHCP (Dynamic Host Configuration Protocol) server.
Group: System/Servers

%description common
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows 
individual devices on an IP network to get their own network 
configuration information (IP address, subnetmask, broadcast address, 
etc.) from a DHCP server.  The overall purpose of DHCP is to make it 
easier to administer a large network.  The dhcp package includes the 
DHCP server and a DHCP relay agent.

You will also need to install the dhcp-client or dhcpcd package,
or pump or dhcpxd, which provides the DHCP client daemon, on 
client machines.
If you want the DHCP server and/or relay, you will al
so need to
install the dhcp-server and/or dhcp-relay packages.

%package server
Summary: The ISC DHCP (Dynamic Host Configuration Protocol) server.
Group: System/Servers
Requires: dhcp-common = %{version} /bin/sh
Obsoletes: dhcp

%description server
DHCP server is the Internet Software Consortium (ISC)
 DHCP server for
 various UNIX operating systems.  It allows a UNIX mac
 hine to serve
 DHCP requests from the network.

 You should install dhcp-server if you want to set up 
 a DHCP server on
 your network.  You will also need to install the base
  dhcp package.
  
%package client
Summary: The ISC DHCP (Dynamic Host Configuration Protocol) client.
Group: System/Servers
Requires: dhcp-common = %{version} /bin/sh

%description client
DHCP client is the Internet Software Consortium (ISC)
 DHCP client for
 various UNIX operating systems.  It allows a UNIX mac
 hine to obtain
 it's networking parameters from a DHCP server.

 You should install dhcp-client if you want to use the
  ISC DHCP client
  instead of the Red Hat DHCP client, pump, or dhcpcd, or dhcpxd.  
  You will also need to install the base dhcp package.

  To use this client with Mandrake instead of dhcpcd, pump, or dhcpxd you m
  ay simply edit
/sbin/ifup:
178c178,187
<	if [ -x /sbin/dhcpcd ];then
<		DHCP_CLIENT=/sbin/dhcpcd
<	elif [ -x /sbin/pump ];then 
<		DHCP_CLIENT=/sbin/pump
<	elif [ -x /sbin/dhcpxd ];then
<		DHCP_CLIENT=/sbin/dhcpxd
<	elif [ -x /sbin/dhclient ];then
<	DHCP_CLIENT=/sbin/dhclient
<	else 
---
<       if [ -x /sbin/dhclient ];then
<       	DHCP_CLIENT=/sbin/dhclient
<       elif [ -x /sbin/dhcpcd ];then
<               DHCP_CLIENT=/sbin/dhcpcd
<       elif [ -x /sbin/pump ];then
<               DHCP_CLIENT=/sbin/pump
<       elif [ -x /sbin/dhcpxd ];then
<               DHCP_CLIENT=/sbin/dhcpxd
<       else


%package relay
Summary: The ISC DHCP (Dynamic Host Configuration Protocol) relay.
Group: System/Servers
Requires: dhcp-common = %{version} /bin/sh

%description relay
DHCP relay is the Internet Software Consortium (ISC) relay agent for 
DHCP packets.  It is used on a subnet with DHCP clients to "relay" 
their requests to a subnet that has a DHCP server
on it.  Because DHCP 
packets can be broadcast, they will not be routed off
of the local 
subnet.  The DHCP relay takes care of this for the client.

You will need to set the environment variable SERVERS
 and optionally
 OPTIONS in /etc/sysconfig/dhcrelay before starting the server.

%package devel
Summary: Development headers and libraries for the dhcpctl API
Group: System/Servers
Requires: dhcp-common = %{version}

%description devel
DHCP devel contains all of the libraries and headers 
for developing with
the Internet Software Consortium (ISC) dhcpctl API.

%prep
%setup -q -a 0 -a 3 -n %{name}-%{version}%{candidate}
%patch0 -p1 
cp %{SOURCE1} doc/

%build
# Attention isn't a autoconf script !!
./configure #--with-nsupdate
#%make CC="gcc -pipe" DEBUG="$RPM_OPT_FLAGS"
%make CC="gcc -pipe" DEBUG="$RPM_OPT_FLAGS -g -D_PATH_DHCPD_DB=\\\"/var/lib/dhcp/dhcpd.leases\\\" -D_PATH_DHCLIENT_DB=\\\"/var/lib/dhcp/dhclient.leases\\\""

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_bindir}

%makeinstall DESTDIR=${RPM_BUILD_ROOT} ADMMANDIR="%{_mandir}/man8" FFMANDIR="%{_mandir}/man5" LIBMANDIR="%{_mandir}/man3" USRMANDIR="%{_mandir}/man1" install 

# use the original omapi.3 because it is preformatted better
# than the one generated by nroff in the makefile:
rm -f %{buildroot}%{_mandir}/man3/omapi.3*
 
# put the preformatted page in cat3:
install -d -m 755 %{buildroot}%{_mandir}/cat3
install -m 644 omapip/omapi.3 %{buildroot}%{_mandir}/cat3

mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_initrddir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/dhcp
cp -a $RPM_BUILD_DIR/%{name}-%{version}%{candidate}/doc/dhcpd.conf.sample $RPM_BUILD_ROOT%{_sysconfdir}
cp -a $RPM_BUILD_DIR/%{name}-%{version}%{candidate}/client/scripts/linux $RPM_BUILD_ROOT%{_sysconfdir}/dhclient-script
touch $RPM_BUILD_ROOT%{_localstatedir}/dhcp/dhcpd.leases
touch $RPM_BUILD_ROOT%{_localstatedir}/dhcp/dhclient.leases
install -m 0755 %{SOURCE2} $RPM_BUILD_ROOT%{_initrddir}/dhcpd
install -m 0755 %SOURCE4 $RPM_BUILD_ROOT%{_initrddir}/dhcrelay
install -m 0755 %SOURCE5 $RPM_BUILD_ROOT%{_sbindir}/
mkdir -p %{buildroot}/%{_sysconfdir}/sysconfig
touch $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/dhcpd
touch $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/dhcrelay

%post server

/sbin/chkconfig --add dhcpd
# New dhcpd lease file
if [ ! -f %{_localstatedir}/dhcp/dhcpd.leases ]; then
    touch %{_localstatedir}/dhcp/dhcpd.leases
fi

if [ $1 = 0 ]; then
	%{_initrddir}/dhcpd start
fi

# Yes. Laziness.
perl -pi -e "s|/etc/rc.d/init.d|%{_initrddir}|" $RPM_BUILD_ROOT%{_initrddir}/*

#update an eventual installed dhcp-2* server
if [ -f %{_sysconfdir}/dhcpd.conf ]; then
	perl %{_sbindir}/update_dhcp.pl
fi

%preun server
%{_initrddir}/dhcpd status | grep running && %{_initrddir}/dhcpd stop >/dev/null 2>&1
if [ $1 = 0 ]; then
    # execute this only if we are NOT doing an upgrade
    /sbin/chkconfig --del dhcpd 
fi

%postun server
if [ "$1" -ge "1" ]; then
            /sbin/service dhcpd condrestart >/dev/null 2>&1  
fi

%post relay
/sbin/chkconfig --add dhcrelay

%preun relay
if [ $1 = 0 ]; then     # execute this only if we ar NOT doing an upgrade
 	/sbin/service dhcrelay stop >/dev/null 2>&1
	/sbin/chkconfig --del dhcrelay
fi
		     
%postun relay
if [ "$1" -ge "1" ]; then
            /sbin/service dhcrelay condrestart >/dev/null 2>&1
fi
		 
%postun client
rm -rf %{_localstatedir}/dhcp/dhcpd.leases

%clean
rm -rf $RPM_BUILD_ROOT

%files common
%defattr(-,root,root)
%doc ANONCVS COPYRIGHT CHANGES README RELNOTES
%doc doc contrib
%dir %{_localstatedir}/dhcp
%attr(644,root,root) %{_mandir}/man5/dhcp-contrib.5*

%files server
%defattr(-,root,root)
%doc %attr(755,root,root) server/dhcpd.conf doc/dhcp-dynamic-dns-examples/*
%config(noreplace) %{_initrddir}/dhcpd
%config(noreplace) %{_sysconfdir}/dhcpd.conf.sample
%config(noreplace) %{_sysconfdir}/sysconfig/dhcpd
%{_sbindir}/dhcpd
%{_sbindir}/update_dhcp.pl
%{_bindir}/omshell
%{_mandir}/man1/omshell.1*
%{_mandir}/man5/dhcpd.conf.5*
%{_mandir}/man5/dhcpd.leases.5*
%{_mandir}/man5/dhcp-options.5*
%{_mandir}/man5/dhcp-eval.5*
%{_mandir}/man8/dhcpd.8*
%config(noreplace) %ghost %{_localstatedir}/dhcp/dhcpd.leases

%files relay
%defattr(-,root,root)
%{_sbindir}/dhcrelay
%{_mandir}/man8/dhcrelay.8*
%config(noreplace) %{_initrddir}/dhcrelay
%config(noreplace) %{_sysconfdir}/sysconfig/dhcrelay

%files client
%defattr(-,root,root)
%doc client/dhclient.conf
%attr(755,root,root) /sbin/dhclient-script
/sbin/dhclient
%{_mandir}/man5/dhclient.conf.5*
%{_mandir}/man5/dhclient.leases.5*
%{_mandir}/man8/dhclient.8*
%{_mandir}/man8/dhclient-script.8*
%config(noreplace) %ghost %{_localstatedir}/dhcp/dhclient.leases

%files devel
%defattr(-,root,root)
%{_mandir}/man3/*
%{_mandir}/cat3/*
%{_prefix}/lib/*
%{_prefix}/include/*

%changelog
* Fri Aug 24 2001 Florin <florin@mandrakesoft.com> 3.0-0.rc12.1mdk
- 3.0rc12

* Thu Aug 16 2001 Florin <florin@mandrakesoft.com> 3.0-0.rc11.1mdk
- 3.0rc11

* Fri Aug 10 2001 Florin <florin@mandrakesoft.com> 3.0-0.rc10.3mdk
- requires /bin/sh

* Tue Jul 17 2001 Florin <florin@mandrakesoft.com> 3.0-0.rc10.2mdk
- test if /etc/dhcpd.conf exists before the update_dhcp script in post

* Mon Jul 02 2001 Florin <florin@mandrakesoft.com> 3.0-0.rc10.1mdk
- 3.0rc10

* Wed Jun 27 2001 Florin <florin@mandrakesoft.com> 3.0-0.rc8pl2.1mdk
- real working example files (the same ones from the bind package)
- 3.0rc8pl2

* Tue Jun 26 2001 Florin Grad <florin@mandrakesoft.com> 3.0-0.rc8pl1.1mdk
- 3.0.rc8pl1
- update the examples files in relation with bind 

* Wed Jun 13 2001 Florin Grad <florin@mandrakesoft.com> 3.0-0.rc8.2mdk
- a better update_dhcp.pl script

* Mon Jun 11 2001 Florin Grad <florin@mandrakesoft.com> 3.0-0.rc8.1mdk
- 3.0rc8
- modify patches
- put dhclient-script in /sbin
- add the update_dhcp.pl script

* Thu May 31 2001 Florin Grad <florin@mandrakesoft.com> 3.0rc7-2mdk
- merge with redhat packages recommended by isc
- so we now have 5 packages: dhcp, dhcp-server, dhcp-relay, dhcp-client, dhcp-devel

* Sun May 27 2001 Stefan van der Eijk <stefan@eijk.nu> 3.0rc7-1mdk
- 3.0rc7

* Tue Mar 27 2001 Florin Grad <florin@mandrakesoft.com> 3.0b2pl23-1mdk
- pl23

* Wed Feb 28 2001 Florin Grad <florin@mandrakesoft.com> 3.0b2pl18-1mdk
- pl18
- update the mdkpathcorrect patch

* Mon Dec 04 2000 Florin Grad <florin@mandrakesoft.com> 3.0b2pl11-1mdk
- pl11

* Fri Nov 17 2000 Florin Grad <florin@mandrakesoft.com> 3.0b2pl9-6mdk
- chkconfig is now set to 345

* Fri Nov 17 2000 Florin Grad <florin@mandrakesoft.com> 3.0b2pl9-5mdk
- add dynamic dns config file example

* Mon Nov 06 2000 Florin Grad <florin@mandrakesoft.com> 3.0b2pl9-4mdk
- minor fixes in the spec files

* Mon Nov 06 2000 Florin Grad <florin@mandrakesoft.com> 3.0b2pl9-3mdk
- fix some errors in the initscripts

* Tue Oct 17 2000 Florin Grad <florin@mandrakesoft.com> 3.0b2pl9-2mdk
- modify the init script not to depend on linuxconf (thanks to A.Skwar) 

* Tue Oct 17 2000 Florin Grad <florin@mandrakesoft.com> 3.0b2pl9-1mdk
- 3.0b2pl9

* Sun Oct 15 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 3.0b2pl8-1mdk
- new patch level version.

* Thu Oct  5 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.0b2pl2-7mdk
- fixes initscript (s/return/exit)

* Thu Sep 28 2000 Florin Grad <florin@mandrakesoft.com> 3.0b2pl2-6mdk
- /etc/dhcpd.conf.sample instead of /etc/dhcpd.conf

* Wed Sep 27 2000 Florin Grad <florin@mandrakesoft.com> 3.0b2pl2-5mdk
- modify dhcpd.init

* Wed Sep 27 2000 Florin Grad <florin@mandrakesoft.com> 3.0b2pl2-4mdk
- make a copy of the *doc*/dhcpd.conf.sample file to /etc/dhcpd.conf

* Thu Sep 21 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.0b2pl2-3mdk
- chkconfig --del has to be done in %preun not %postun !!

* Tue Sep 07 2000 Florin Grad <florin@mandrakesoft.com> 3.0b2pl2-2mdk
- adding noreplace in the config section 

* Thu Sep 07 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 3.0b2pl2-1mdk
- new and shiny dhcp.

* Tue Aug 30 2000 Florin Grad <florin@mandrakesoft.com> 3.0b1pl17-6mdk
- recompile because of some modif on rpm

* Tue Aug 29 2000 Florin Grad <florin@mandrakesoft.com> 3.0b1pl17-5mdk
- updating the macros

* Mon Jul 24 2000 Vincent Saugey <vince@mandrakesoft.com> 3.0b1pl17-4mdk
- Really fixed this update script

* Mon Jul 24 2000 Vincent Saugey <vince@mandrakesoft.com> 3.0b1pl17-3mdk
- Fix a little typo error in upgrade script

* Fri Jul 21 2000 Vincent Saugey <vince@mandrakesoft.com> 3.0b1pl17-2mdk
- Remove older patch remade clean one
- corrected init file (no more error for config without linux-conf)
- Now, full FHS compliant, with leases in /var/lib/dhcpd

* Fri Jul 21 2000 Vincent Saugey <vince@mandrakesoft.com> 3.0b1pl17-1mdk
- Up to 3.0b1pl17
- Slipt in 3 packages, new one for relay.
- Correct man file path
- Clean spec file (use macro)

* Sat Jul  1 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0b1pl15-1mdk
- Fix %doc.
- 3.0b1pl15.

* Wed Jun 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0b1pl12-6mdk
- Correct patches.

* Wed Jun 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0b1pl12-5mdk
- Add security patch.
- Clan upmacros spec file.

* Thu Apr 13 2000 Vincent Saugey <vince@mandrakesoft.com> 3.0b1pl12-4mdk
- Made init script at config file

* Fri Mar 24 2000 - Jean-Michel Dault <jmdault@mandrakesoft.com> 3.0b1pl12-3mdk
- modified init script so it binds to the correct interface. It reads
  /etc/conf.linuxconf to do it.

* Tue Mar 21 2000 - Vincent Saugey <vince@mandrakesoft.com> 3.0b1pl12-2mdk
- correct group

* Mon Dec 06 1999 - David BAUDENS <baudens@mandrakesoft.com>
- Fix build as user
- Add "%%define prefix /usr"
- Replace /%%{prefix} by  %%{prefix}

* Mon Dec 01 1999 Philippe Libat <philippe@mandrakesoft.com>
- Subpackages dhcp-client
- Upgrade of patch.
- Change dhcpd.leases directory

* Mon Jul 12 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Prefixing the package.
- Upgrade of patch.
- 3.0b1pl0.

* Tue May 11 1999 Bernhard Rosenkraenzer <bero@mandrakesoft.com>
- Mandrake adaptions

* Tue Apr 06 1999 Preston Brown <pbrown@redhat.com>
- strip binaries

* Mon Apr 05 1999 Cristian Gafton <gafton@redhat.com>
- copy the source file in %prep, not move

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Mon Jan 11 1999 Erik Troan <ewt@redhat.com>
- added a sample dhcpd.conf file
- we don't need to dump rfc's in /usr/doc

* Sun Sep 13 1998 Cristian Gafton <gafton@redhat.com>
- modify dhcpd.init to exit if /etc/dhcpd.conf is not present

* Sat Jun 27 1998 Jeff Johnson <jbj@redhat.com>
- Upgraded to 2.0b1pl6 (patch1 no longer needed).

* Thu Jun 11 1998 Erik Troan <ewt@redhat.com>
- applied patch from Chris Evans which makes the server a bit more paranoid
  about dhcp requests coming in from the wire

* Mon Jun 01 1998 Erik Troan <ewt@redhat.com>
- updated to dhcp 2.0b1pl1
- got proper man pages in the package

* Tue Mar 31 1998 Erik Troan <ewt@redhat.com>
- updated to build in a buildroot properly
- don't package up the client, as it doens't work very well <sigh>

* Tue Mar 17 1998 Bryan C. Andregg <bandregg@redhat.com>
- Build rooted and corrected file listing.

* Mon Mar 16 1998 Mike Wangsmo <wanger@redhat.com>
- removed the actual inet.d links (chkconfig takes care of this for us)
  and made the %postun section handle upgrades.

* Mon Mar 16 1998 Bryan C. Andregg <bandregg@redhat.com>
- First package.
